#include<iostream>
using namespace std;
int main(){

long long n;
cin>>n;
long long chisla[n], golqmoPredi=0, golqmoSega=0, izhod=10000000;

for(int i=0; i<n; i++){
    cin>>chisla[i];
}

for(int i=1; i<n-1; i++){
    if(chisla[i]>chisla[i+1] && chisla[i]>chisla[i-1]){
        golqmoPredi=golqmoSega;
        golqmoSega=i;
        int razlika=(max(golqmoPredi, golqmoSega)+1)-(min(golqmoPredi, golqmoSega)-1);
        if(razlika<izhod){
            izhod=razlika;
        }
    }
}

cout<<izhod<<endl;

return 0;
}

